/* ==================== Globals =================== */
var totalPages, activeTab = "", currentPage, pageId = 1,
    myScroll, pullDownEl, pullDownOffset, pullUpEl, pullUpOffset, scrollPos,
    searchQuery, searchType, imageData = "",
    submitImage = false, clicked = false, isLoggedIn = false,
    plantId, userId, iFollow, newUser = false, me = {},
    footerTop = 0, bodyClass = "home",
    plantsCache = [], usersCache = [], searchCache = [], activityCache = [], userActivityCache = [], plantCache = [],
    busy = false;

$(document).bind("deviceready", function () {
    initializeOAuth();
    //document.addEventListener("backbutton", onBackBtn, false);
});

$(document).bind("mobileinit", function() {
    $.mobile.defaultPageTransition = 'none';
    //$.mobile.page.prototype.options.domCache = true;
    $.mobile.phonegapNavigationEnabled = true;
    $.mobile.useFastClick  = false;
});
/* ============================= Functions  ========================*/
function changeBodyClass(className) {

    $("body").removeClass(bodyClass);
    bodyClass = className;
    $("body").addClass(bodyClass);
}

function login(username, password, force) {
    if (busy) {
        return false;
    }

    localStorage["autologin"] = "true";
    localStorage["username"] = username;
    localStorage["password"] = password;

    busy = true;
    oauthAuthorize(username,password, function (result) {
        if (result) {
            oauthAccessToken(function (result) {
                if (result) {
                    isLoggedIn = true;
                    getMe();
                } else {
                    navigator.notification.vibrate(100);
                    navigator.notification.alert(
                        _('loginError'), null,
                        _('notificationErrorTitle'));
                    enableLoginButton();
                }
            }, true);
        } else {
            if (navigator.notification !== undefined) {
                navigator.notification.vibrate(100);
                navigator.notification.alert(
                    _('emailPassError'), null,
                    _('notificationErrorTitle'));
            }
            localStorage["autologin"] = "false";
            localStorage["username"] = '';
            localStorage["password"] = '';
            enableLoginButton();
        }
        busy = false;
    }, force);
}
function register($button) {
    if (!isOnline()) return false;

    var parameters = {
        email: $('#email').val(),
        password: $('#pass').val(),
        firstname: $('#firstname').val(),
        lastname: $('#lastname').val()
    };

    if (parameters.email == '' || parameters.password == '' || parameters.firstname == '' || parameters.lastname == '') {
        navigator.notification.vibrate(100);
        navigator.notification.alert(
            _('uncompleteFieldsError'), null,
            _('notificationErrorTitle'));
        return false;
    }

    $("#registerform .cancel").hide();
    $('#registerBtn').addClass("btn-busy").find(".ui-btn-text").text(_('registering'));

    apiAjax('users/register', parameters, function (data) {
        if (data.errors) {
            var errors = '';
            $.each(data.errors, function (index, value) {
                errors += value + "\n";
            });
            navigator.notification.vibrate(100);
            navigator.notification.alert(
                errors, null,
                _('notificationErrorTitle'));

            enableRegistrationForm();
        } else {
            oauthRequestToken(function (result) {
                if (result) {
                    newUser = true;
                    login(parameters.email, parameters.password, true);
                } else {
                    navigator.notification.vibrate(100);
                    navigator.notification.alert(
                        _('initError'), enableLoginButton(),
                        _('notificationErrorTitle'));
                }
            });
        }
    });
}
function clearRegistrationForm() {
    $("#registerform #firstname").val("");
    $("#registerform #lastname").val("");
    $("#registerform #email").val("");
    $("#registerform #pass").val("");
}
function enableRegistrationForm() {
    $("#registerform .cancel").show();
    $('#registerBtn').removeClass("btn-busy").find(".ui-btn-text").text(_('register'));
    $('#pass').val("");
}

function getMe() {
    apiAjax('users/show', {user_id: 'me', image_size: "b"}, function (data) {
        me = {id: data.id,
            username: data.username,
            firstname: data.firstname,
            lastname: data.lastname,
            country: data.country,
            city: data.city,
            latlng: data.latlng,
            gardenSize: data.gardenSize,
            numberOfFollowers: data.numberOfFollowers,
            numberOfPlants: data.numberOfPlants,
            photo: data.photo
        };
        toggleLoggedIn();
        $.mobile.changePage('#home');
        clearRegistrationForm();
        enableRegistrationForm();
    });
}
function toggleLoggedIn() {
    if (isLoggedIn) {
        $('#homeMenu').removeClass('notLoggedIn');
        $('#account').html('<small><a id="profile" href="#"><img src="' + me.photo + '" width="28" height="28"> ' + me.firstname + ' ' + me.lastname + '</a> &bull; <a href="#" id="logout">' + _('logoutBtnText') + '</a></small>');
    } else {
        $('#homeMenu').addClass('notLoggedIn');
        $('#account').html('<a href="#login" data-role="button" data-theme="b" class="ui-btn ui-btn-corner-all ui-shadow ui-btn-up-b"><span class="ui-btn-inner ui-btn-corner-all" aria-hidden="true"><span class="ui-btn-text" id="loginBtnText">' + _('loginBtnText') + '</span></span></a><small id="homeFooterText">' + _('homeFooterText') + '</small>');

        enableLoginButton();
    }
}
function enableLoginButton() {
    if ($('#loginBtn').length > 0) {
        $('#loginBtn').removeClass("btn-busy").find(".ui-btn-text").text(_('loginBtnText'));
    }
}
function getActivities() {
    if (activityCache[activeTab] && (currentPage == pageId)) {
        $('.loader').hide();

        toggleDragUp('actPullUp', totalPages > 1);

        $('ul#activitiesList').html(activityCache[activeTab]);
        setTimeout(function () {
            myScroll.refresh();
        });
        if (scrollPos < -55) {
            setTimeout(function () {
                myScroll.scrollTo(0, scrollPos, 200);
            }, 1000);
        }
    } else {
        var parameters = {image_size: "b", page: pageId};
        apiAjax('activities/'+activeTab, parameters, function (data) {
            renderActivities(data, $('#actWrapper'), $('ul#activitiesList'));
        });
    }

    currentPage = pageId;
}

function renderActivities(data, element, ulist) {
    if (pageId == 1) {
        ulist.empty();
    }
    $('.loader').hide();
    totalPages = data.pages;

    if (totalPages == 0) {
        ulist.empty();
        ulist.html('<li data-detail="no" class="ui-btn ui-li ui-li-has-thumb activity"> \
                <div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a href="#" class="ui-link-inherit">'
            + '<p class="ui-li-desc emptymessage"><br/>' + _("noActivities") + '</p>' +
            '</a></div></div> \
            </li>');
        $('#actPullDown span').hide();
        $('#actPullUp span').hide();
        toggleDragUp('actPullUp', false);
        return;
    } else {
        $('#actPullDown span').show();
        $('#actPullUp span').show();
    }

    toggleDragUp('actPullUp', totalPages > 1);

    var list = '';
    for (var i in data.activities) {
        var comments = stats = '';
        var numComments = data.activities[i].numberOfComments;
        var numLikes = data.activities[i].numberOfLikes;

        if (numComments != 0 && numComments != undefined) {
            var comment = '';
            for ( var j in data.activities[i].lastComments) {
                comment += '<li ' + ((j == 1 || numComments == 1)?'class="last-child"':'') + '><p class="ui-li-desc username">'+data.activities[i].lastComments[j].userName+'</p> \
                    <p class="ui-li-desc date">'+ data.activities[i].lastComments[j].niceDate + '</p> \
                    <p class="ui-li-desc comment">'+ data.activities[i].lastComments[j].message + '</p> \
                    </li>';
            }
            comments = '<ul class="comments">'+ comment +'</ul>';
        }

        var stats = '';
        if ((numComments != 0 && numComments != undefined) || (numLikes != 0 && numLikes != undefined)) {
            stats = '<div class="stats">'+
                ((numComments != 0 && numComments != undefined)? '<div class="nrComments">'+ numComments + pluralise(' ' + _("reaction"), ' ' + _("reactions"), numComments) + '</div>' : '' ) +
                ((numLikes != 0 && numLikes != undefined)? '<div class="nrLikes">'+ numLikes + pluralise(' ' + _("gardenerLike"),' ' + _("gardenersLike"), numLikes) + '</div>' : '' ) +
                '</div>';
        }
        var activity = '';
        if (data.activities[i].activity == 'postTweet') {
            activity = '<img src="' + data.activities[i].user.photo + '" class="ui-li-thumb" width="60" height="60"/> \
                    <p class="ui-li-desc username">' + data.activities[i].userName + '</p> \
                    <p class="ui-li-desc date">' + data.activities[i].niceDate + '</strong></p>' +
                ((data.activities[i].images)? '<p class="ui-li-desc"><img class="picture" src="' + data.activities[i].images[0].photo + '"  width="98" height="98" /></p>' : '' ) +
                '<p class="ui-li-desc message">' + data.activities[i].message + '</p>';
        } else if (data.activities[i].activity == 'commentPhoto') {
            activity = '<img src="' + data.activities[i].user.photo + '" class="ui-li-thumb" width="60" height="60"/> \
                    <p class="ui-li-desc username">' + data.activities[i].comment.userName + '</p> \
                    <p class="ui-li-desc date">' + data.activities[i].niceDate + '</strong></p> \
                    <p class="ui-li-desc"><img class="picture" src="' + data.activities[i].picture.photo + '"  width="98" height="98" /></p> \
                    <p class="ui-li-desc message">' + data.activities[i].comment.message + '</p> \
                    <p class="ui-li-desc message">' + data.activities[i].message + '</p>';
        } else if (data.activities[i].activity == 'addPhoto') {
            activity = '<img src="' + data.activities[i].user.photo + '" class="ui-li-thumb" width="60" height="60"/> \
                    <p class="ui-li-desc message">' + data.activities[i].message + '</p>' +
                ((data.activities[i].photo.photo)?
                    '<p class="ui-li-desc"><img class="picture" src="' + data.activities[i].photo.photo + '"  width="98" height="98" /></p>'
                    : '') +
                '<p class="ui-li-desc date">' + data.activities[i].niceDate + '</strong></p>';
        } else if (data.activities[i].activity == 'addPlantPhoto') {
            activity = '<img src="' + data.activities[i].user.photo + '" class="ui-li-thumb" width="60" height="60"/> \
                    <p class="ui-li-desc message">' + data.activities[i].message + '</p> \
                    <p class="ui-li-desc"><img class="picture" src="' + data.activities[i].photo.photo + '"  width="98" height="98" /></p> \
                    <p class="ui-li-desc date">' + data.activities[i].niceDate + '</strong></p>';
        } else {
            activity = '<img src="' + data.activities[i].user.photo + '" class="ui-li-thumb" width="60" height="60"/> \
                    <p class="ui-li-desc message">' + data.activities[i].message + '</p> \
                    <p class="ui-li-desc date">' + data.activities[i].niceDate + '</strong></p>';
        }
        var detail = (data.activities[i].activity == 'likeActivity' ||  data.activities[i].activity == 'commentArticle') ? 'no' : 'yes';
        list += '<li data-activityid="'+data.activities[i].id+'" data-theme="c" data-detail="' + detail + '" class="ui-btn ui-li ui-li-has-thumb activity"> \
                <div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a href="#" class="ui-link-inherit">'
            + activity + stats + ' ' + comments +
            '</a></div></div> \
            </li>';
    }
    ulist.append(list);
    if (myScroll) {
        setTimeout(function () {
            myScroll.refresh();
        });
    }
}

function getActivity(id) {
    $.mobile.changePage( 'activitydetail.html' );
    $('#activityDetailContent').empty();
    $('.stats').remove();
    $('li').not('#commentBox').remove();
    apiAjax('activities/show', {activity_id: id, image_size: "b"}, function (data) {
        var comments = '';
        var stats = '';
        var numComments = data.numberOfComments;
        var numLikes = data.numberOfLikes;
        $('#activityDetailContent').html('<img class="avatar" src="' + data.user.photo + '" class=""> \
                    <p class="username">' + data.userName + '</p> \
                    <p class="date">' + data.niceDate + '</strong></p>' +
            ((data.activity == 'postTweet' && data.images)? '<p><a href="' + getFullImage(data.images[0].photo) + '" class="fancybox"><img class="picture" src="' + data.images[0].photo + '" /></a></p>' : '') +
            ((data.activity == 'commentPhoto')? '<p><a href="' + getFullImage(data.picture.photo) + '" class="fancybox"><img class="picture" src="' + data.picture.photo + '" /></a></p>' : '') +
            ((data.activity == 'addPhoto' || data.activity == 'addPlantPhoto')? '<p><a href="' + getFullImage(data.photo.photo) + '" class="fancybox"><img class="picture" src="' + data.photo.photo + '" /></a></p>' : '') +
            '<p class="ui-li-desc message">' + ((data.activity == 'commentPhoto')? data.comment.message : data.message) + '</p>');

        $('<div class="stats">' +
            ((numComments != 0 && numComments != undefined)? '<div class="nrComments">'+ numComments + pluralise(_('commentsSingle'), _('commentsMultiple'), numComments) + '</div>' : '' ) +
            ((numLikes != 0 && numLikes != undefined)? '<div class="nrLikes">'+ numLikes + pluralise(_('gardenersLikeSingle'),_('gardenersLikeMultiple'), numLikes) + '</div>' : '' ) +
            '</div>').insertBefore('.comments');

        if (data.activity != 'commentPhoto' || data.activity != 'likeActivity') {
            $('.comments').show();
            $('#likeBtn').removeClass('like unlike').addClass((data.iLiked == 1)? 'like' : 'unlike');
        }

        if (numComments != 0 && numComments != undefined) {
            var comment = '';
            for ( var j in data.comments) {
                comment += '<li ' + ((j == numComments-1)?'class="last-child"':'') + '> \
                    <img src="'+data.comments[j].photo+'" width="40" height="40" /> \
                    <p class="ui-li-desc username">'+data.comments[j].userName+'</p> \
					<p class="ui-li-desc date">'+ data.comments[j].niceDate + '</p> \
					<p class="ui-li-desc">'+ data.comments[j].message + '</p> \
					</li>';
            }
            $('.comments').prepend(comment);
        };
        $('#activityId').val(data.id);
        $('#postStatus').show();
        clicked = false;
    });

}

function postComment() {
    if ($("#commentField").val() != '') {
        apiAjax('activities/comment', {activity_id: $("#activityId").val(),text : $("#commentField").val()}, function (data) {
            $("#commentField").val('');
            getActivity($("#activityId").val());
        },'GET');
    }
}

function likeActivity(type) {
    if ($("#activityId").val() != '') {
        apiAjax('activities/' + type, {activity_id: $("#activityId").val()}, function (data) {
            getActivity($("#activityId").val());
        },'GET');
    }
}

function postStatus() {
    if ($("#statusMsg").val() == '') {
        navigator.notification.vibrate(100);
        navigator.notification.alert(_('emptyMessage'));
        return;
    }
    $('#submitButton').hide();
    $('#postLoader').find('.loadLabel').html(submitImage? _('uploading') : _('sending'));
    $('#postLoader').show();
    var tweetData = {};
    setTimeout(function () {
        tweetData.text = $("#statusMsg").val();
        if (!imageData && submitImage) {
            postStatus();
            return;
        }
        tweetData.image = imageData;
        apiAjax('tweets/publish', tweetData, function (data) {
            navigator.notification.alert(_('messageSent'), function () {
                $('#statusBack').click();
            }, 'Info');
            $("#statusMsg").val('');
            tweetData = {};
            imageData = '';
            submitImage = false;
            $('#submitButton').show();
            $('#postLoader').hide();
            $('#cameraReadyBtn').hide();
            $('#cameraBtns').show();
        },'POST');
    }, 100);
}

function getPlants(method) {
    if (plantsCache[activeTab] && (currentPage == pageId)) {
        $('.loader').hide();

        toggleDragUp('plantsPullUp', totalPages > 1);

        $('ul#plantsList').html(plantsCache[activeTab]);
        setTimeout(function () {
            myScroll.refresh();
        });
        if (scrollPos < -55) {
            setTimeout(function () {
                myScroll.scrollTo(0, scrollPos, 200);
            }, 1000);
        }
    } else {
        var url = (method == 'my')? 'garden/show' : 'plants/'+method;
        var parameters = (method == 'my')? {user_id : 'me'} : {};
        parameters.image_size = "b";
        parameters.page = pageId;
        apiAjax(url, parameters, function (data) {
            renderPlants(data)
        });
    }
    currentPage = pageId;
}

function renderPlants(data) {
    var ulist = $('ul#plantsList');
    if (pageId == 1) {
        $('ul#plantsList').empty();
    }

    $('.loader').hide();
    totalPages = data.pages;
    if (totalPages == 0) {
        ulist.append('<li data-detail="no" class="ui-btn ui-li ui-li-has-thumb activity"> \
                <div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a href="#" class="ui-link-inherit">' +
            '<p class="ui-li-desc emptymessage">' + ('noPlantsInGarden') + '</p>' +
            '<p class="ui-li-desc emptymessage">' + ('addPlantsToGardenMsg') + '</p>' +
            '</a></div></div> \
            </li>');
        $('#plantsPullDown span').hide();
        $('#plantsPullUp span').hide();
        toggleDragUp('plantsPullUp', false);
        return;
    } else {
        $('#plantsPullDown span').show();
        $('#plantsPullUp span').show();
    }

    toggleDragUp('plantsPullUp', totalPages > 1);

    var list = '';
    for (var i in data.plants) {
        list += '<li data-theme="c" class="ui-btn ui-li ui-li-has-thumb plant"  data-plantid="'+data.plants[i].id+'"><div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a class="ui-link-inherit"> \
                <img src="' + data.plants[i].photo + '" class="ui-li-thumb"> \
                <p class="ui-li-desc plantName">' + data.plants[i].name + '</p> \
                <p class="ui-li-desc">' + data.plants[i].latinName + '</p> \
                <p class="ui-li-desc info">' + sprintf(pluralise(_('growsInGardenSingle'), _('growsInGardenMulti'),  data.plants[i].numberOfFollowers), data.plants[i].numberOfFollowers) + '</p> \
            </a></div></div></li>';
    }
    ulist.append(list);
    setTimeout(function () {
        myScroll.refresh();
    });
}
var plantSummery = '';

function getPlant(plant_id) {
    clicked = true;
    $.mobile.changePage( 'plantdetail.html' );
    $('#plantDetailBody').empty();
    apiAjax('plants/show', {plant_id: plantId, image_size: "l"}, function (data) {
        //console.log(data);
        //var data = plantDetailData;
        var properties = '';
        for (var i in data.properties) {
            properties += '<li><strong>' + i + ':</strong> ' + data.properties[i] + '</li>';
        }
        var plantProperties = (properties) ? '<ul class="plantProperties">' + properties + '</ul>' : '';
        plantSummery = '<div id="plantSummary" class="detail plant"> \
        			<h2 class="plantName">'+data.name+'</h2> \
        			<h3 class="latinName">'+data.latinName+'</h3> \
        			</div>';
        var plantDetail = plantSummery + '<div id="plantDescription" class="detail plant contentBlock"> \
        			' + ((isLoggedIn) ? '<a  id="addBtn" href="#" data-type="plants"  data-theme="b" class="ui-btn ui-btn-corner-all ui-shadow ui-btn-up-b"><span class="ui-btn-inner ui-btn-corner-all" aria-hidden="true"><span class="ui-btn-text">' + _('addToGarden') + '</span></span></a>' : '') + ' \
        			<div class="height"><img src="assets/icons/height.png">&nbsp;&nbsp; '+data.minHeight+' - '+data.maxHeight+' cm</div> \
					<div class="properties">' + plantProperties + '</div> \
					<div class="description" id="description">'+data.description+'</div> \
				</div>';
        $('#plantDetailBody').html(plantDetail);
        if (isLoggedIn) {
            toggleFollowPlant(data.iFollow);
        }
        clicked = false;
    });
}

function getPlantMedia() {
    $.mobile.changePage( 'plantmedia.html' );
    $('#plantMediaBody').empty();
    apiAjax('plant-photos/plant', {plant_id: plantId, image_size: "f"}, function (data) {
    //var data = plantMediaData;
        var plantMedia = '';
        for (var i in data) {
            plantMedia += '<li><a href="' + data[i].photo + '"><img src="' + data[i].photo + '" width="98" height="98"/></a></li>';
        }
        $('#plantMediaBody').html(plantSummery + '<ul id="gallery">' + plantMedia + '</ul>');
        var myPhotoSwipe = $("#gallery a").photoSwipe({ enableMouseWheel: false , enableKeyboard: false, captionAndToolbarAutoHideDelay: 0 });
    });
}

function getPlantTasks() {
    $.mobile.changePage( 'planttasks.html' );
    $('#plantTasksBody').empty();
    apiAjax('plants/actions', {plant_id: plantId, image_size: "l"}, function (data) {
    //var data = planTasksData;
        var plantTasks = '';
        for (var i in data) {
            plantTasks += '<div class="contentBlock"><h2>' + data[i].name + '</h2>';
            var periods = '';
            for (var j in data[i].periods) {
                periods += data[i].periods[j].period;
            }
            plantTasks += '<h3>' + periods + '</h3><p>' + data[i].description + '</p></div>';
        }
        $('#plantTasksBody').html(plantSummery + '<div id="plantTasks">' + plantTasks + '</div>');
    });
}

function addRemovePlant(follow, list) {
    if (clicked) return;
    clicked = true;
    var parameters = {
        plant_id: plantId
        //description: ""
    };

    apiAjax('plants/'+((follow) ? 'add' : 'remove' ), parameters, function (data) {
        clicked = false;
        $('#addBtn').removeClass("btn-busy");
        toggleFollowPlant(follow);
    });
    plantsCache['my'] = undefined;
}

function toggleFollowPlant(follow) {
    if (follow) {
        $('#addBtn').removeClass('follow').addClass('unfollow').html(_('removeFromGarden'));
    } else {
        $('#addBtn').removeClass('unfollow').addClass('follow').html(_('addToGarden'));
    }
}

function getUsers(method) {
    if (usersCache[activeTab] && (currentPage == pageId)) {
        $('.loader').hide();
        toggleDragUp('usersPullUp', totalPages > 1);

        $('ul#usersList').html(usersCache[activeTab]);
        setTimeout(function () {
            myScroll.refresh();
        });
        if (scrollPos < -55) {
            setTimeout(function () {
                myScroll.scrollTo(0, scrollPos, 200);
            }, 1000);
        }

    } else {
        var url = 'users/'+ method;
        var parameters = (method == 'friends')? {user_id : 'me'} : {};
        parameters.image_size = "b";
        parameters.page = pageId;
        apiAjax(url, parameters, function (data) {
            renderUsers(data);
        });
    }
    currentPage = pageId;
}

function renderUsers(data) {
    var ulist = $('ul#usersList');
    if (pageId == 1) {
        ulist.empty();
    }
    $('.loader').hide();
    totalPages = data.pages;

    if (totalPages == 0) {
        ulist.append('<li data-detail="no" class="ui-btn ui-li ui-li-has-thumb activity"> \
                <div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a href="#" class="ui-link-inherit">' +
            '<p class="ui-li-desc emptymessage">' + _('noFavorites') + '</p>' +
            '<p class="ui-li-desc emptymessage">' + _('addGardenersMsg') + '</p>' +
            '</a></div></div> \
            </li>');
        $('#usersPullDown span').hide();
        $('#usersPullUp span').hide();
        toggleDragUp('usersPullUp', false);
        return;
    } else {
        $('#usersPullDown span').show();
        $('#usersPullUp span').show();
    }

    toggleDragUp('usersPullUp', totalPages > 1);

    var list = '';
    for (var i in data.users) {
        list += '<li data-theme="c" class="user ui-btn ui-li ui-li-has-thumb"" data-userid="'+data.users[i].id+'"><div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a class="ui-link-inherit"> \
	                <img src="' + data.users[i].photo + '" class="ui-li-thumb"> \
	                <p class="username">' + data.users[i].firstname + ' ' + data.users[i].lastname + '</p> \
	                <p class="info">' + data.users[i].city + ((data.users[i].gardenSize != 0.00)? ' &bull; <span>' + data.users[i].gardenSize + '</span> ' + _('sizeGarden') : '') + '<br/> \
	                ' + data.users[i].numberOfFollowers + ' ' + pluralise(_('fanSingle'), _('fanMultiple'), data.users[i].numberOfFollowers) + ' &bull; \
	                ' + data.users[i].numberOfFollowing + ' ' + pluralise(_('favoriteSingle'), _('favoriteMultiple'), data.users[i].numberOfFollowing) + '  &bull; \
	                ' + data.users[i].numberOfPlants + ' ' + pluralise(_('plantsSingle'), _('plantsMultiple'), data.users[i].numberOfPlants) + '</p> \
               	</a></div><span class="ui-icon ui-icon-arrow-r ui-icon-shadow"></span></div></li>';
    }
    ulist.append(list);
    setTimeout(function () {
        myScroll.refresh();
    });
}

function getUser(user_id) {
    clicked = true;
    userId = user_id;
    $.mobile.changePage( 'userdetail.html' );
    $('#userDetailBody').empty();
    apiAjax('users/show', {user_id: userId, image_size: "l"}, function (data) {
        var userDetail = '<div id="userDetail" class="detail user"> \
					<span class="photo"><img src="'+data.photo+'" width="100"/></span> \
					<h2 class="userName">'+ data.firstname + ' ' + data.lastname +'</h2> \
					<h3>'+ data.city + ((data.gardenSize != 0.00)? ' &bull; <span>' + data.gardenSize + '</span> '+_('sizeGarden') : '') + '</h3> \
					<p class="ui-li-desc description">' + data.biography + '</p> \
					<ul class="stats"> \
					<li class="first"><strong>' + data.numberOfFollowers + '</strong> ' + pluralise(_('fanSingle'), _('fanMultiple'),data.numberOfFollowers) + '</li> \
					<li><strong>' + data.numberOfFollowing + '</strong> ' + pluralise(_('favoriteSingle'), _('favoriteMultiple'), data.numberOfFollowing) + '</li> \
					<li class="last"><strong>' + data.numberOfPlants + '</strong> ' + pluralise(_('plantsSingle'), _('plantsMultiple'), data.numberOfPlants) + '</li> \
					</ul> \
                </div>';

        $('#userDetailBody').html(userDetail).append('<a id="followBtn" href="#" data-type="users"  data-theme="b" class="ui-btn ui-btn-corner-all ui-shadow ui-btn-up-b"><span class="ui-btn-inner ui-btn-corner-all" aria-hidden="true"><span class="ui-btn-text"></span></span></a>');

        if (me.id != user_id) {
            iFollow = data.iFollow;
            toggleFollowButton(data.iFollow);
        } else {
            $('#followBtn').hide();
        }
        clicked = false;

        getUserActivities();
    });
}

function getUserActivities() {
    var parameters = {
        user_id: userId,
        image_size: 'm'
    };

    apiAjax('activities/user', parameters , function (data) {
        renderActivities(data, $('#actUserWrapper'), $('#userActivitiesList'));
    });
}

function followUnfollow(follow) {
    if (clicked) return;
    clicked = true;
    $('#followBtn').addClass('btn-busy');
    var parameters = {
        user_id: userId
        //description: ""
    };
    apiAjax('users/'+((follow) ? 'follow' : 'unfollow' ), parameters, function (data) {
        iFollow = follow;
        $('#followBtn').removeClass('btn-busy');
        toggleFollowButton(follow);
        clicked = false;
    });
    usersCache['friends'] = undefined;
}

function toggleFollowButton(follow) {
    if (follow) {
        $('#followBtn').html(_('unfollow')).removeClass('follow').addClass('unfollow');
    } else {
        $('#followBtn').html(_('follow')).removeClass('unfollow').addClass('follow');
    }
}

function search(query) {
    var parameters = {};
    parameters.query = $.trim(query);
    parameters.image_size = "b";
    parameters.page = pageId;

    apiAjax(searchType+'/search', parameters, function (data) {
        myScroll.scrollTo(0,0,0);
        renderSearch(data);
    });

    currentPage = pageId;
}

function renderSearch(data) {
    if (pageId == 1) $('ul#searchList').empty();
    totalPages = data.pages;
    var list = '';
    switch (searchType) {
        case "plants":
            if (data.plants == undefined) {
                myScroll.disable();
                $('ul#searchList').append('<li data-theme="c" style="text-align: center">' + _('noResults') + '</li>');
                $('#searchPullUp').hide();
            }
            for (var i in data.plants) {
                myScroll.enable();
                list += '<li data-theme="c" class="plant ui-btn ui-li ui-li-has-thumb plant"  data-plantid="'+data.plants[i].id+'"><div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                        <a class="ui-link-inherit"> \
                        <img src="' + data.plants[i].photo + '" class="ui-li-thumb"> \
                        <p class="ui-li-desc plantName">' + data.plants[i].name + '</p> \
                        <p class="ui-li-desc">' + data.plants[i].latinName + '</p> \
                        <p class="ui-li-desc">' + sprintf(pluralise(_('growsInGardenSingle'), _('growsInGardenMulti'), data.plants[i].numberOfFollowers), data.plants[i].numberOfFollowers) +'</p> \
                    </a></div></div></li>';
            }
            $('ul#searchList').append( list );
            break;
        case "users":
            if (data.users == undefined) {
                $('ul#searchList').append('<li data-theme="c" style="text-align: center">' + _('noResults') + '</li>');
                $('#searchPullUp').hide();
            }
            for (var i in data.users) {
                list += '<li data-theme="c" class="user ui-btn ui-li ui-li-has-thumb user"" data-userid="'+data.users[i].id+'"><div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a class="ui-link-inherit"> \
	                <img src="' + data.users[i].photo + '" class="ui-li-thumb"> \
	                <p class="username">' + data.users[i].firstname + ' ' + data.users[i].lastname + '</p> \
	                <p class="info">' + data.users[i].city + ((data.users[i].gardenSize != 0.00)? ' &bull; <span>' + data.users[i].gardenSize + '</span> ' + _('sizeGarden') : '') + '<br/> \
	                ' + data.users[i].numberOfFollowers + ' ' + pluralise(_('fanSingle'), _('fanMultiple'), data.users[i].numberOfFollowers) + ' &bull; \
	                ' + data.users[i].numberOfFollowing + ' ' + pluralise(_('favoriteSingle'), _('favoriteMultiple'), data.users[i].numberOfFollowing) + '  &bull; \
	                ' + data.users[i].numberOfPlants + ' ' + pluralise(_('plantsSingle'), _('plantsMultiple'), data.users[i].numberOfPlants) + '</p> \
               	</a></div><span class="ui-icon ui-icon-arrow-r ui-icon-shadow"></span></div></li>';
            }
            $('ul#searchList').append(list);
            break;
    }
    $('.loader').hide();
    toggleDragUp('searchPullUp', totalPages > 1);

    setTimeout(function () {
        myScroll.refresh();
    });
}

function getTodos() {
    var url = 'todos';
    apiAjax(url, {image_size:"b"}, function (data) {
        pageId = 1;
        renderTodos(data);
    });
    currentPage = pageId;
}

function renderTodos(data) {
    var ulist = $('ul#todoList');
    if (pageId == 1) {
        ulist.empty();
    }
    $('.loader').hide();
    toggleDragUp('todoPullUp', false);

    if (data.todos.length == 0) {
        ulist.append('<li data-detail="no" class="ui-btn ui-li ui-li-has-thumb activity"> \
                <div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a href="#" class="ui-link-inherit">'
            + '<p class="ui-li-desc emptymessage"><br/>&nbsp;&nbsp;&nbsp; ' + _("noTodos") + '</p>' +
            '</a></div></div> \
            </li>');

        myScroll.disable();
        return;
    }

    var list = '';
    for (var i in data.todos) {
        list += '<li data-theme="c" class="user ui-btn ui-li ui-li-has-thumb todo"" data-plantid="'+data.todos[i].plant.id+'" data-plantactionid="'+data.todos[i].plantAction.id+'"><div class="ui-btn-inner ui-li"><div class="ui-btn-text"> \
                <a class="ui-link-inherit"> \
	                <img src="' + data.todos[i].plant.photo + '" class="ui-li-thumb"> \
	                <p class="todoName">' + data.todos[i].plantAction.name + ' &raquo; ' + data.todos[i].plant.name + '</p> \
	                <p class="info">' + data.todos[i].plantAction.period + '</p> \
               	</a></div><span class="ui-icon ui-icon-arrow-r ui-icon-shadow"></span></div></li>';
    }
    ulist.append(list);
    setTimeout(function () {
        myScroll.refresh();
    },100);
}

function getPlantAction(plantId, plantActionId) {
    $.mobile.changePage( 'tododetail.html' );
    $('#todoDetailBody').empty();
    apiAjax('plants/actions/show', {plant_id:plantId, plant_action_id: plantActionId}, function (data) {
        var todoDetail = '<div id="todoDetail" class="detail plant"> \
					<span class="photo"><img src="'+data.plant.photo+'" width="150"/> \
                    <a  id="markDoneBtn" href="#" data-plantactionid="' + plantActionId + '" data-theme="b" class="ui-btn ui-btn-corner-all ui-shadow ui-btn-up-b"><span class="ui-btn-inner ui-btn-corner-all" aria-hidden="true"><span class="ui-btn-text">' + _('markAsDone') + '</span></span></a> \
                    <a  id="markRemoveBtn" href="#" data-plantactionid="' + plantActionId + '" data-theme="c" class="ui-btn ui-btn-corner-all ui-shadow ui-btn-up-c"><span class="ui-btn-inner ui-btn-corner-all" aria-hidden="true"><span class="ui-btn-text">' + _('markAsRemove') + '</span></span></a> \
                    </span> \
					<h2 class="todoName">'+capitaliseFirstLetter(data.name)+'</h2> \
					<h2 class="plantName">'+data.plant.name+'</h2> \
					<h3 class="latinName">'+data.plant.latinName+'</h3> \
					<div class="info"><strong>' + data.period +'</strong></div> \
					<div class="description" id="description">'+data.description+'</div> \
				</div>';
        $('#todoDetailBody').html(todoDetail);
    });
}

function markAsDone(plantActionId) {
    $('#markDoneBtn').addClass('btn-busy');
    apiAjax('plant-actions/mark-as-done', {plant_action_id: plantActionId}, function (data) {
        $('#markDoneBtn, #markRemoveBtn').remove();
        navigator.notification.alert(data.messages[0]);
    });
}

function markAsRemove(plantActionId) {
    $('#markRemoveBtn').addClass('btn-busy');
    apiAjax('plant-actions/remove', {plant_action_id: plantActionId}, function (data) {
        $('#markDoneBtn, #markRemoveBtn').remove();
        navigator.notification.alert(data.messages[0]);
    });
}

function getFullImage(src) {
    var words = ['_s', '_m', '_c', '_b', '_l' ];
    if(typeof(src) != "undefined") {
        return src.replace(new RegExp('(' + words.join('|') + ')', 'g'), '_f');
    } else {
        return '';
    }
}


/* ================== Nationalisation =============== */

/* Translate by class */
function c(elements) {
    var i=0;
    var total=elements.length;
    for(i;i<total;i++) {
        $('.'+elements[i]).html(_(elements[i]));
    }
}
/* Translate the elements of a page  */
function t(elements) {
    var i=0;
    var total=elements.length;
    for(i;i<total;i++) {
        te(elements[i]);
    }
}
/* Translate the string of an element */
function te(element) {
    var e = document.getElementById(element);
    if (!e) return;
    e.innerHTML = _(element);
}
/* Update a elements attribute */
function ta(element, attr) {
    var e = document.getElementById(element);
    if (!e) return;
    e.setAttribute(attr, _(element));
}

function _(s) {
    if (typeof(i18n)!='undefined' && i18n[s]) {
        return i18n[s];
    }
    return s;
}

function pluralise(s, p, n) {
    if (n != 1) return _(p);
    return _(s);
}

function sprintf(s) {
    var bits = s.split('%');
    var out = bits[0];
    var re = /^([ds])(.*)$/;
    for (var i=1; i<bits.length; i++) {
        var p = re.exec(bits[i]);
        if (!p || arguments[i]==null) continue;
        if (p[1] == 'd') {
            out += parseInt(arguments[i], 10);
        } else if (p[1] == 's') {
            out += arguments[i];
        }
        out += p[2];
    }
    return out;
}

/* ==================== Helpers =================== */

function capitaliseFirstLetter(string)
{
    return string.charAt(0).toUpperCase() + string.slice(1);
}

function isOnline() {
    if (navigator.network != undefined) {
        if (navigator.network.connection.type == Connection.NONE || navigator.network.connection.type == Connection.UNKNOWN) {
            navigator.notification.alert(_('noConnection'));
            return false
        } else {
            return true;
        }
    } else {
        return true;
    }
}

/* ==================== oAuth ================= */

function initializeOAuth() {
    oauthRequestToken(function (result) {

        if (localStorage["autologin"] == "true") {
            login(localStorage["username"], localStorage["password"], false);
            return;
        }
        if (result) {
            $.mobile.loadPage('#login');
            oauthAccessToken(function (result) {
                if (!result) {
                    navigator.notification.alert(
                        _('connectionError'), enableLoginButton(),
                        _('notificationErrorTitle')
                    );
                }
            },false);
        } else {
            navigator.notification.vibrate(100);
            navigator.notification.alert(
                _('initError'), function () {
                    enableLoginButton();
                },_('notificationErrorTitle')
            );
        }

    });
}

function oauthRequestToken(callback) {
    var accessor = { consumerSecret: $.consumerSecret
        , tokenSecret: null };
    var message = { action: $.apiUrl + 'oauth/request_token'
        , method: 'GET'
        , parameters: { oauth_consumer_key: $.consumerKey
            , oauth_signature_method: $.signatureMethod }
    };
    OAuth.setTimestampAndNonce(message);
    OAuth.SignatureMethod.sign(message, accessor);
    var parameters = OAuth.getParameterMap(message.parameters);
    $.get(message.action, parameters, function (data) {
        var token = data.match(/^oauth_token=([^&]*)&oauth_token_secret=([^&]*)$/);
        if (token) {
            $.requestToken = token[1];
            $.requestTokenSecret = token[2];
            callback(true);
        } else {
            if (data.match(/Expired timestamp/)) {
                navigator.notification.vibrate(100);
                navigator.notification.alert(
                    _('connectionTimestampError'), function () {
                        enableLoginButton();
                    },_('notificationErrorTitle')
                );
            } else {
                callback(false);
            }
        }
    }).error(function () {
            navigator.notification.alert(
                _('connectionError'), enableLoginButton(),
                _('notificationErrorTitle')
            );
        });
}

function oauthAuthorize(email, password, callback, force) {
    var forceLogin = (force)? 'force_login=1&' : '';
    var url = $.oauthAuthorizeUrl + '?' + forceLogin + 'oauth_token=' + $.requestToken;
    $.post(url, { email: email, password: password }, function (data) {
        if (!data.match(/Invalid token/) && !data.match(/Invalid username or password/)) {
            var token = data.match(/^oauth_token=([^&]*)&oauth_verifier=([^&]*)$/);
            if (token) {
                $.verifier = token[2];
                if (token[1] == $.requestToken && $.verifier) {
                    callback(true);
                } else {
                    callback(false);
                }
            } else {
                callback(false);
            }
        } else {
            callback(false);
        }
    });
}

function oauthAccessToken(callback, auth) {
    var accessor = { consumerSecret: $.consumerSecret
        , tokenSecret: $.requestTokenSecret };
    var message = { action: $.apiUrl + 'oauth/access_token'
        , method: 'GET'
        , parameters: { oauth_consumer_key: $.consumerKey
            , oauth_token: $.requestToken
            , oauth_signature_method: $.signatureMethod }
    };
    if (auth) {
        message.parameters.oauth_verifier = $.verifier;
    }
    OAuth.setTimestampAndNonce(message);
    OAuth.SignatureMethod.sign(message, accessor);
    var parameters = OAuth.getParameterMap(message.parameters);
    $.get(message.action, parameters, function (data) {
        var token = data.match(/^oauth_token=([^&]*)&oauth_token_secret=([^&]*)$/);
        if (token) {
            $.accessToken = token[1];
            $.accessTokenSecret = token[2];
            callback(true);
        } else {
            callback(false);
        }
    });
}

function apiAjax(uri, parameters, callback, method) {
    var accessor = { consumerSecret: $.consumerSecret
        , tokenSecret: $.accessTokenSecret };
    if (method == undefined) {
        method = 'GET';
    }
    parameters.oauth_consumer_key = $.consumerKey;
    parameters.oauth_token = $.accessToken;
    parameters.oauth_signature_method = $.signatureMethod;
    var message = { action: $.apiUrl + uri
        , method: method
        , parameters: parameters
    };
    OAuth.setTimestampAndNonce(message);
    OAuth.SignatureMethod.sign(message, accessor);
    var parameters = OAuth.getParameterMap(message.parameters);
    $.ajax({
        type: method,
        url: message.action,
        data: parameters,
        success: callback,
        dataType: 'json'
    });
}
/*
function onBackBtn() {

}
*/
/**
 *
 * ISCroller
 *
 */
function toggleDragUp(pullUp, show) {
    pullUpEl = document.getElementById(pullUp);
    if (pullUpEl == null) return;
    pullUpEl.style.display = (show)? 'block' : 'none';
    setTimeout(function () {
        myScroll.refresh();
    });
}

function loaded(pullDown, pullUp, wrapper, list, pullDownAction, pullUpAction) {
    pullDownEl = document.getElementById(pullDown);
    pullDownOffset = 40;
    pullUpEl = document.getElementById(pullUp);
    pullUpOffset = 40;
    myScroll = new iScroll(wrapper, {
        useTransition: false,
        hScroll: false,
        topOffset: pullDownOffset,
        onRefresh: function () {
            if (pullDownEl.className.match('loading')) {
                pullDownEl.className = '';
                pullDownEl.querySelector('.pullDownLabel').innerHTML = _("pullDownLabel");
            } else if (pullUpEl.className.match('loading')) {
                pullUpEl.className = '';
                pullUpEl.querySelector('.pullUpLabel').innerHTML = _("pullUpLabel");
            }
        },
        onScrollMove: function () {
            if (this.y > 5 && !pullDownEl.className.match('flip')) {
                pullDownEl.className = 'flip';
                pullDownEl.querySelector('.pullDownLabel').innerHTML = _("pullReleaseText");
                this.minScrollY = 0;
            } else if (this.y < 5 && pullDownEl.className.match('flip')) {
                pullDownEl.className = '';
                pullDownEl.querySelector('.pullDownLabel').innerHTML = _("pullDownLabel");
                this.minScrollY = -pullDownOffset;
            } else if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip')) {
                pullUpEl.className = 'flip';
                pullUpEl.querySelector('.pullUpLabel').innerHTML = _("pullReleaseText");
                this.maxScrollY = this.maxScrollY;
            } else if (this.y > (this.maxScrollY + 5) && pullUpEl.className.match('flip')) {
                pullUpEl.className = '';
                pullUpEl.querySelector('.pullUpLabel').innerHTML = _("pullUpLabel");
                this.maxScrollY = pullUpOffset;
            }
        },
        onScrollEnd: function () {
            if (pullDownEl.className.match('flip')) {
                pullUpEl.style.display = 'block';
                pullDownEl.className = 'loading';
                pullDownEl.querySelector('.pullDownLabel').innerHTML =  _("loadLabel");
                pullDownAction(list);
            } else if (pullUpEl.className.match('flip')) {
                pullUpEl.style.display = 'block';
                pullUpEl.className = 'loading';
                pullUpEl.querySelector('.pullUpLabel').innerHTML = _("loadLabel");
                pullUpAction(list);
            }
        }
    });
    $('#actPullUp, #actUserPullUp, #plantsPullUp, #usersPullUp, #searchPullUp, #todoPullUp').hide();
    setTimeout(function () { document.getElementById(wrapper).style.left = '0'; }, 800);
}

/* Phonegap Photo */
// Called when a photo is successfully retrieved
function onPhotoDataSuccess(data) {
    $('#cameraReadyBtn').show();
    $('#cameraBtns').hide();
    $('#postLoader').hide().find('.loadLabel').html(_('uploading'));
    $('#submitButton').show();
    imageData = data;
}

function getPhoto(source) {
    submitImage = true;
    $('#postLoader').show().find('.loadLabel').html(_('loadingPicture'));
    $('#submitButton').hide();
    // Retrieve image file location from specified source
    navigator.camera.getPicture(onPhotoDataSuccess, onFail, { quality: 60, destinationType: Camera.DestinationType.DATA_URL ,sourceType: source, correctOrientation: true, saveToPhotoAlbum: true });
}

function onFail(message) {
    $('#postLoader').hide();
    $('#submitButton').show();
}

/* ============================= Pages  ========================*/

$('#home').live('pageinit', function () {

}).live('pagebeforeshow', function (event) {
    t(["homePlantBtnText", "homePostBtnText", "homeActBtnText", "homeUsersBtnText", "homeToDoBtnText", "homeEventsBtnText", "loginBtnText", "homeFooterText"]);
}).live('pageshow', function () {
	changeBodyClass("home");
	footerTop = screen.height - 100;
});

$('#login').live('pagebeforeshow', function (event) {
    $('#username').val('');
    $('#password').val('');
    t(["loginBtnText2", "loginCancelBtn", "loginFooterText"]);
    ta("username", "placeholder");
    ta("password", "placeholder");
});

$('#registerPage').live('pagebeforeshow', function (event) {
	ta("firstname", "placeholder");
	ta("lastname", "placeholder");
	ta("email", "placeholder");
	ta("pass", "placeholder");
	t(["registerBtnText", "registerCancelBtn", "registerFooterText"]);
});

$('#infoPage').live('pagebeforeshow', function (event) {
	t(["infoText", "backBtn"]);
});

$('#activities').live('pageinit', function (event) {
    clicked = false;
    setTimeout(
        function () {
            loaded('actPullDown', 'actPullUp', 'actWrapper', 'activitiesList',
                function (list) {
                     getActivities();
                },
                function (list) {
                    if (pageId >= totalPages) {
                        toggleDragUp('actPullUp', false);
                        return;
                    }
                    pageId++;
                    getActivities();
                })
        }, 200);

    //default load all messages
    pageId = 1;
        
    activeTab = "all";
    $('#all').addClass('ui-btn-active').parent().addClass('active');
    
	getActivities();
    $('#network').click(function () {
        scrollPos = 0;
        myScroll.scrollTo(0,0,0);
        pageId = 1;
		activeTab = "my-network";
        $('ul#activitiesList').empty();
        $('.loader').show();
        toggleDragUp('actPullUp', false);
        getActivities();
    });
	$('#all').click(function () {
        myScroll.scrollTo(0,0,0);
        scrollPos = 0;
        pageId = 1;
		activeTab = "all";
        $('ul#activitiesList').empty();
        $('.loader').show();
        toggleDragUp('actPullUp', false);
        getActivities();
    });
	$('#popular').click(function () {
        myScroll.scrollTo(0,0,0);
        scrollPos = 0;
        pageId = 1;
		activeTab = "popular";
        $('ul#activitiesList').empty();
        $('.loader').show();
        toggleDragUp('actPullUp', false);
        getActivities();
    });
}).live('pagebeforeshow', function () {
    t(["activitiesTitle", "network", "popular", "all"]);
    c(["pullDownLabel", "loadLabel", "pullUpLabel"]);
    //$('.ui-footer').attr('style','top:'+footerTop+'px');
});

$('#postStatus').live('pageinit', function (event) {
    $('.postAvatar').attr('src', me.photo);
    /*
	$('#postTweet').submit(function () {
		postStatus();
		return false;
	});
	*/
}).live('pagebeforeshow', function () {
    imageData = '';
    submitImage = false;
    t(["postStatusTitle", "cameraReadyBtnText", "cameraBtnsText", "postLoaderText", "sendBtnText"]);
    ta("statusMsg", "placeholder");
});

$('#plants').live('pageinit', function (event) {
    clicked = false;

    switch(activeTab) {
        case "my":
            $('#popularPlants').removeClass('ui-btn-active');
            $('#myPlants').addClass('ui-btn-active');
            $('#plantsTitle').html(_('plantsTitleMine'));
            break;
        case "top":
            $('#myPlants').removeClass('ui-btn-active');
            $('#popularPlants').addClass('ui-btn-active');
            $('#plantsTitle').html(_('plantsTitleAll'));
            break;
    }
    setTimeout(
        function () {
            loaded('plantsPullDown', 'plantsPullUp', 'plantsWrapper', 'plantsList',
                function (list) {
                     getPlants(activeTab);
                },
                function (list) {
                    if (pageId >= totalPages) {
                        toggleDragUp('plantsPullUp', false);
                        return;
                    }
                    pageId++;
                    getPlants(activeTab);
                })
        }, 200);
	getPlants(activeTab);
	$('#myPlants').click(function () {
		$('#plantsTitle').html(_('plantsTitleMine'));
        scrollPos = 0;
		myScroll.scrollTo(0,0,0);
        pageId = 1;
		activeTab = "my";
        $('ul#plantsList').empty();
        $('.loader').show();
        toggleDragUp('plantsPullUp', false);
		getPlants(activeTab);
	});
	//$('#allPlants').click(function () {getPlants('all')});
	$('#popularPlants').click(function () {
		$('#plantsTitle').html(_('plantsTitleAll'));
        scrollPos = 0;
		myScroll.scrollTo(0,0,0);
        pageId = 1;
		activeTab = "top";
        $('ul#plantsList').empty();
        $('.loader').show();
        toggleDragUp('plantsPullUp', false);
		getPlants(activeTab);
	});
}).live('pagebeforeshow', function () {
    //$('.ui-footer').attr('style','top:'+footerTop+'px');
    if (!isLoggedIn) {
        $('.subnav').hide();
        $('#plantsWrapper').addClass('notLoggedIn');
    } else {
        $('.subnav').show();
        $('#plantsWrapper').removeClass('notLoggedIn');
    }
    t(["plantsTitle", "myPlants", "popularPlants"]);
    c(["pullDownLabel", "loadLabel", "pullUpLabel"]);
});

$('#plantDetail').live('pagebeforeshow', function () {
    c(["loadLabel"]);
}).live('pageinit', function (event) {
    getPlant();
}).live('pagebeforeshow', function () {
    c(["plantInfo", "plantTasks", "plantMedia"]);
});

$('#plantMedia').live('pagebeforeshow', function () {
    c(["loadLabel"]);
}).live('pageinit', function (event) {
    getPlantMedia();
}).live('pagebeforeshow', function () {
    c(["plantInfo", "plantTasks", "plantMedia"]);
});


$('#plantTasks').live('pagebeforeshow', function () {
    c(["loadLabel"]);
}).live('pageinit', function (event) {
    getPlantTasks();
}).live('pagebeforeshow', function () {
    c(["plantInfo", "plantTasks", "plantMedia"]);
});

$('#users').live('pageinit', function (event) {
    clicked = false;
    switch(activeTab) {
        case "my":
            $('#popularUsers').removeClass('ui-btn-active');
            $('#myUsers').addClass('ui-btn-active');
            break;
        case "top":
            $('#myUsers').removeClass('ui-btn-active');
            $('#popularUsers').addClass('ui-btn-active');
            break;
    }
    setTimeout(
        function () {
            loaded('usersPullDown', 'usersPullUp', 'usersWrapper', 'usersList',
                function (list) {
                     getUsers(activeTab);
                },
                function (list) {
                    if (pageId >= totalPages) {
                        toggleDragUp('usersPullUp', false);
                        return;
                    }
                    pageId++;
                    getUsers(activeTab);
                })
        }, 200);
	getUsers(activeTab);
	$('#myUsers').click(function () {
        scrollPos = 0;
        myScroll.scrollTo(0,0,0);
        pageId = 1;
		activeTab = "friends";
        $('ul#usersList').empty();
        $('.loader').show();
        toggleDragUp('usersPullUp', false);
        getUsers(activeTab);
    });
	$('#latestUsers').click(function () {
        scrollPos = 0;
        myScroll.scrollTo(0,0,0);
        pageId = 1;
        activeTab = "all";
        $('ul#usersList').empty();
        $('.loader').show();
        toggleDragUp('usersPullUp', false);
        getUsers(activeTab);
    });
	$('#popularUsers').click(function () {
        scrollPos = 0;
        myScroll.scrollTo(0,0,0);
        pageId = 1;
        activeTab = "top";
        usersCache[activeTab] = undefined;
        $('ul#usersList').empty();
        $('.loader').show();
        toggleDragUp('usersPullUp', false);
        getUsers(activeTab);
    });
}).live('pagebeforeshow', function () {
    t(["popularUsers", "myUsers", "usersTitle"]);
    c(["pullDownLabel", "loadLabel", "pullUpLabel"]);
    //$('.ui-footer').attr('style','top:'+footerTop+'px');
});

$('#activityDetail').live('pageinit', function (event) {
    $('.postAvatar').attr('src', me.photo);
}).live('pagebeforeshow', function () {
    if (activityCache['detail']) {
        $('#actDetailContent').html(activityCache['detail']);
    }
    c(["loadLabel"]);
    t(["commentBtnText"]);
    ta("commentField", "placeholder");
});

$('#userDetail').live('pageinit', function (event) {
    scrollPos = 0;
}).live('pageshow', function (event) {
    if (userActivityCache['info']) {
        $('#userDetailBody').html(userActivityCache['info']);
        $('ul#userActivitiesList').html(userActivityCache['list']);
         if (me.id != userId) {
            toggleFollowButton(iFollow);
        } else {
            $('#followBtn').hide();
        }
    }
}).live('pagebeforeshow', function () {
	t(["userDetailTitle", "userActivitesLoadText"]);
    c(["loadLabel"]);
});

$('#search').live('pageinit', function (event) {
	pageId = 1;
    setTimeout(
        function () {
            loaded('searchPullDown', 'searchPullUp', 'searchWrapper', 'searchList',
                function (list) {
                     search(searchQuery, 1);
                },
                function (list) {
                    if (pageId >= totalPages) {
                        toggleDragUp('searchPullUp', false);
                        return;
                    }
                    pageId++;
                    search(searchQuery, pageId);
                })
        }, 200);
}).live('pageshow', function (event) {
    switch(searchType) {
        case 'users':
             $('#pageTitle').text(_('searchGardeners'));
             $('#searchWrapper').addClass('users');
        break;
        case 'plants':
             $('#pageTitle').text(_('searchPlants'));
        break;
    }

    $('.loader').hide();
    $('#searchField').focus();
    if (searchCache[searchType]) {
        $('ul#searchList').html(searchCache[searchType]);
        setTimeout(function () {
            myScroll.refresh();
        });
        if (scrollPos < -55) {
            setTimeout(function () {
                myScroll.scrollTo(0, scrollPos, 200);
            }, 1000);
        }
    }
}).live('pagebeforeshow', function () {
	ta("searchField", "placeholder");
    c(["pullDownLabel", "loadLabel", "pullUpLabel"]);
});


$('#todo').live('pageinit', function (event) {
    clicked = false;
    toggleDragUp('todoPullUp', false);
    setTimeout(
        function () {
            loaded('todoPullDown', 'todoPullUp', 'todoWrapper', 'todoList',
                function (list) {
                     getTodos();
                },
                function (list) {
                    toggleDragUp('todoPullUp', false);
                    return;
                    /*
                    if (pageId >= totalPages) {
                        toggleDragUp('todoPullUp', false);
                        return;
                    }
                    pageId++;
                    getTodos();
                    */
                })
        }, 200);
	getTodos();
}).live('pagebeforeshow', function () {
    t(["todoTitle"]);
    c(["pullDownLabel", "loadLabel", "pullUpLabel"]);
});

/* =========================== EventListeners ======================*/

$('#homePlantBtn').live('click', function () {
    if (!isOnline()) return false;
    activeTab = (isLoggedIn)? "my" : "top";
    pageId = 1;
    scrollPos = 0;
	changeBodyClass("plants");
    $.mobile.changePage( "plants.html" );

    //$.mobile.changePage( 'plantdetail.html' );
});

$('#homeUsersBtn').live('click', function () {
    if (!isOnline()) return false;
    activeTab = "top";
    pageId = 1;
    scrollPos = 0;
    if (!isLoggedIn) {
        $.mobile.changePage( "#login" );
        return false;
    } else {
        $.mobile.changePage( "users.html" );
    }
    changeBodyClass("users");
});

$('#homeActBtn').live('click', function () {
    if (!isOnline()) return false;
    activeTab = "my-network";
    pageId = 1;
    scrollPos = 0;
    if (!isLoggedIn) {
        $.mobile.changePage( "#login" );
        return false;
    } else {
        $.mobile.changePage( "activities.html" );
    }
    changeBodyClass("activities");
});

$('#homePostBtn').live('click', function () {
    if (!isOnline()) return false;
    pageId = 1;
    scrollPos = 0;
    if (!isLoggedIn) {
        $.mobile.changePage( "#login" );
        return false;
    } else {
        $.mobile.changePage( "post.html" );
    }
    changeBodyClass("post");
});

$('#homeToDoBtn').live('click', function () {
    if (!isOnline()) return false;
    pageId = 1;
    scrollPos = 0;
    if (!isLoggedIn) {
        $.mobile.changePage( "#login" );
        return false;
    } else {
        $.mobile.changePage( "todo.html" );
    }
    changeBodyClass("todo");
});

$('#loginBtn').live('click', function () {
    if (!isOnline()) return false;

    var $username = $('#username').val();
    var $password = $('#password').val();
    if ( $username == '' || $password == '') {
        navigator.notification.vibrate(100);
        navigator.notification.alert(
                        _('notificationErrorLogin'), null,
                        _('notificationErrorTitle'));
        return false;
    }

    $(this).addClass("btn-busy").find(".ui-btn-text").text(_('loggingInMsg'));

    oauthRequestToken(function (result) {
        if (result) {
            login($username, $password, true);
        } else {
            navigator.notification.vibrate(100);
            navigator.notification.alert(
                        _('initError'), enableLoginButton(),
                        _('notificationErrorTitle'));
        }
    });
    changeBodyClass("home");
});
$('#profile').live('click', function () {
    changeBodyClass("users");
    getUser(me.id);
});
$('#logout').live('click', function (evt) {
    localStorage["autologin"] = "false";
    localStorage["username"] = "";
    localStorage["password"] = "";
    isLoggedIn = false;
    userId = undefined;
    me = {};
    $.requestToken = '';
    $.requestTokenSecret = '';
    $.verifier = '';
    toggleLoggedIn();
    initializeOAuth();
    changeBodyClass("home");
});
$('#registerBtn').live('click', function (evt) {
    register($(this));
    changeBodyClass("home");
    return false;
});

$('a[target="_blank"]').live('click', function(evt){
	evt.preventDefault();
	var ref = window.open($(this).attr("href"), '_blank', '');
});

$('ul#plantsList').find('li').live('click', function () {
    if ($(this).data('detail') == 'no') return false;
    scrollPos = myScroll.y;
    plantsCache[activeTab] = $('ul#plantsList').html();
    if (!clicked) {
        plantId = $(this).data('plantid');
	    getPlant();
    }
	return false;
});

$('ul#usersList').find('li').live('click', function () {
    if ($(this).data('detail') == 'no') return false;
    scrollPos = myScroll.y;
    usersCache[activeTab] = $('ul#usersList').html();
    userActivityCache = [];
    if (!clicked) {
        getUser($(this).data('userid'));
    }
	return false;
});

$('ul#searchList').find('li').live('click', function () {
    scrollPos = myScroll.y;
    searchCache[searchType] = $('ul#searchList').html();
    if ($(this).hasClass('plant')) {
        plantId = $(this).data('plantid');
	    getPlant();
    }
    if ($(this).hasClass('user')) {
	    getUser($(this).data('userid'));
    }
    return false;
});

$('ul#activitiesList').find('li.activity').live('click', function () {
    scrollPos = myScroll.y;
    if ($(this).data('detail') == 'yes') {
        activityCache[activeTab] = $('ul#activitiesList').html();
	    getActivity($(this).data('activityid'));
    }
	return false;
});

$('ul#userActivitiesList').find('li.activity').live('click', function () {
    scrollPos = myScroll.y;
    activityCache['detail'] = undefined;
    if ($(this).data('detail') == 'yes') {
        userActivityCache['info'] = $('#userDetailBody').html();
        userActivityCache['list'] = $('ul#userActivitiesList').html();
	    getActivity($(this).data('activityid'));
    }
	return false;
});

$('ul#todoList').find('li').live('click', function () {
    scrollPos = myScroll.y;
    //plantsCache[activeTab] = $('ul#plantsList').html();
    if (!clicked && !$(this).data('detail')) {
	    getPlantAction($(this).data('plantid'), $(this).data('plantactionid'));
    }
	return false;
});

$('#submitStatus').live('click', function () {
    postStatus();
	return false;
});

$('#likeBtn').live('click', function () {
	likeActivity($(this).hasClass('like')?'unlike':'like');
	return false;
});

$('#postComment').live('click', function () {
	postComment();
	return false;
});

$('#searchBtn').live('click', function () {
    searchType = $(this).data('type');
    switch(searchType) {
        case 'plants':
            plantsCache[activeTab] = $('#plantsList').html();
            break;
        case 'users':
            usersCache[activeTab] = $('#usersList').html();
            break;
    }
    $.mobile.changePage( "search.html" );
    return false;
});

$('#searchForm').live('submit', function () {
    searchQuery = $('#searchField').val();
    if (searchQuery == '' || searchQuery.length < 3) {
        navigator.notification.vibrate(100);
                    navigator.notification.alert(
                        _('searchErrorMsg'), null,
                        _('notificationErrorTitle'));
        return false;
    }
    $('.loader').show();
    pageId = 1;
    $('ul#searchList').empty();
    searchCache[searchType] = undefined;
    search(searchQuery);
    $('#searchField').blur();
	return false;
});

$('#albumBtn').live('click', function () {
     getPhoto(pictureSource.SAVEDPHOTOALBUM);
});

$('#cameraBtn').live('click', function () {
     getPhoto(pictureSource.CAMERA);
});

$('#addBtn').live('click', function () {
    $(this).addClass("btn-busy");
    addRemovePlant($(this).hasClass('follow'), 'garden');
});

$('#followBtn').live('click', function () {
    followUnfollow($(this).hasClass('follow'));
});

$('#markDoneBtn').live('click', function () {
    markAsDone($(this).data('plantactionid'));
});

$('#markRemoveBtn').live('click', function () {
    markAsRemove($(this).data('plantactionid'));
});

$('#userDetailLink').live('click', function () {
    if (!clicked) {
        activityCache['detail'] = $('#actDetailContent').html();
        getUser($(this).data('userid'));
    }
});
/*
$('.plantInfo').live('click', function () {
    $.mobile.changePage( 'plantdetail.html' );
});

$('.plantTasks').live('click', function () {
    $.mobile.changePage( 'planttasks.html' );
});

$('.plantMedia').live('click', function () {
    $.mobile.changePage( 'plantmedia.html' );
});
*/
$('.fancybox').fancybox({padding:0, closeBtn:false, closeClick: true,
    helpers : {
        overlay : {
            css : {'background' : 'rgba(0, 0, 0, 0.7)'}
        }
    }
});
